VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmCriticalAnalyser 
   AutoRedraw      =   -1  'True
   BackColor       =   &H8000000A&
   Caption         =   "Critical Path Analyser"
   ClientHeight    =   6510
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   8025
   FillColor       =   &H80000018&
   FillStyle       =   0  'Solid
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   6.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   6510
   ScaleWidth      =   8025
   StartUpPosition =   2  'CenterScreen
   Begin MSComDlg.CommonDialog Dlg 
      Left            =   7020
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DefaultExt      =   "xml"
      FileName        =   "*.xml"
      Filter          =   "*.xml"
      FilterIndex     =   1
      FontName        =   "Verdana"
   End
   Begin VB.Menu mnuFile 
      Caption         =   "File"
      Begin VB.Menu mnuFileNew 
         Caption         =   "New"
      End
      Begin VB.Menu mnuFileOpen 
         Caption         =   "Open..."
      End
      Begin VB.Menu mnuSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileSave 
         Caption         =   "Save"
      End
      Begin VB.Menu mnuFileSaveAs 
         Caption         =   "Save As..."
      End
      Begin VB.Menu mnuSep2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "Exit"
      End
   End
   Begin VB.Menu mnuMode 
      Caption         =   "Mode"
      Begin VB.Menu mnuModeAnalyse 
         Caption         =   "Analyse Mode"
      End
      Begin VB.Menu mnuModeEdit 
         Caption         =   "Edit Mode"
         Checked         =   -1  'True
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "Edit"
      Visible         =   0   'False
      Begin VB.Menu mnuEditAddNode 
         Caption         =   "Add Node"
      End
      Begin VB.Menu mnuEditEditNode 
         Caption         =   "Edit Node"
      End
      Begin VB.Menu mnuEditDeleteNode 
         Caption         =   "Delete Node"
      End
      Begin VB.Menu mnuSep3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuEditAddLink 
         Caption         =   "Add Link"
      End
      Begin VB.Menu mnuEditDeleteLink 
         Caption         =   "Delete Link"
      End
      Begin VB.Menu mnuSep4 
         Caption         =   "-"
      End
      Begin VB.Menu mnuEditClearSelection 
         Caption         =   "Clear Selection"
      End
      Begin VB.Menu mnuEditAnalyseMode 
         Caption         =   "Analyse Mode"
      End
   End
   Begin VB.Menu mnuAnalyse 
      Caption         =   "Analysis"
      Enabled         =   0   'False
      Begin VB.Menu mnuAnalyseCriticalTree 
         Caption         =   "Critical Path"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnuAnalyseGantt 
         Caption         =   "Gantt Chart"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "Help"
      Begin VB.Menu mnuHelpBuilding 
         Caption         =   "Building Webs"
      End
      Begin VB.Menu mnuHelpAnalysis 
         Caption         =   "Analysis"
      End
   End
End
Attribute VB_Name = "frmCriticalAnalyser"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private mSelection As tSelection
Private mDirtyWeb As Boolean
Private mResize As Boolean
Private mXDown As Single
Private mYDown As Single
Private mEditHeight As Single
Private mEditWidth As Single

Public Enum eFileAction
    eOpen = 1
    eSaveAs = 2
End Enum

Private Type tSelection
    Nd1 As Node
    Nd2 As Node
End Type
Public Sub ClearSelection()

    With mSelection
        Set .Nd1 = Nothing
        Set .Nd2 = Nothing
    End With

End Sub

Public Sub SelectNode(X As Single, Y As Single, RG As Long)
Dim dx As Single, dy As Single
Dim Nodes As Variant
Dim Index As Integer

    'Select a node and turn it green or red depending on whether it is the first or second node to be selected
    'There is a neat bit of hit-testing here that determines whether the mouse X,Y lies over a node
    Nodes = gNodes.Items
    For Index = 0 To UBound(Nodes)
        If Not Nodes(Index).Key = cSTART And Not Nodes(Index).Key = cFINISH Then
            dx = Nodes(Index).X - X
            dy = Nodes(Index).Y - Y
            If dx * dx + dy * dy <= cSELRADIUS Then
                If Nodes(Index) Is mSelection.Nd1 Then Exit Sub
                If RG = vbGreen Then
                    Set mSelection.Nd1 = Nodes(Index)
                Else
                    Set mSelection.Nd2 = Nodes(Index)
                End If
                DrawEdit mSelection.Nd1, mSelection.Nd2
                SetEditMenu
                Exit Sub
            End If
        End If
    Next
    ClearSelection
    SetEditMenu
    
End Sub



Private Sub Form_Load()
    mEditHeight = Height
    mEditWidth = Width
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    'Convert the mouse X and Y so it lies on the grid
    SnapToGrid X, Y
    'Store the values in module wide variables
    mXDown = X
    mYDown = Y
    If Button = vbRightButton Then
        If Not mSelection.Nd1 Is Nothing Then SelectNode X, Y, vbRed
        PopupMenu mnuEdit
    Else
        SelectNode X, Y, vbGreen
    End If
    RefreshDisplay
    
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim dx As Single, dy As Single

    If mSelection.Nd1 Is Nothing Then Exit Sub
    If Button = vbLeftButton Then
        SnapToGrid X, Y
        If Not mSelection.Nd1.X = X Or Not mSelection.Nd1.Y = Y Then
            mSelection.Nd1.X = X
            mSelection.Nd1.Y = Y
            DrawEdit mSelection.Nd1, mSelection.Nd1
        End If
    End If
    

End Sub


Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If gDirtyFile Then
        If MsgBox("Save changes", vbYesNo + vbQuestion) = vbYes Then FileSave
    End If
    Cleanup
End Sub



Public Sub AddNode(X As Single, Y As Single)
Dim Nd As Node
Dim Nodes As Variant
Dim Index As Integer
Dim NodeData As frmAddNode
On Local Error GoTo DuplicateKey
    
    'This Proc adds a node to the growing web structure
    
    'Get all the nodes out of the dictionary
    Nodes = gNodes.Items
    'Check to see if this position is already occupied by a node
    For Index = 0 To UBound(Nodes)
        If Nodes(Index).X = X And Nodes(Index).Y = Y Then Exit Sub
    Next
    'Collect the node's data from the user via the AddNode form.
    'Loop until the user enter valid data to create the new node
    Do
        Set NodeData = New frmAddNode
        With NodeData
            gNextKey = gNextKey + 1
            .Caption = "Add New Node"
            .Key = gNextKey
            .Show vbModal, Me
            If .Cancelled Then Exit Sub
            If Not Len(.Key.Text) = 0 And Not Len(.Length.Text) = 0 And IsNumeric(.Length.Text) Then Exit Do
            MsgBox "Please enter a Key and a numeric Length"
        End With
    Loop
    
    'Use the data collected to instantiate a new node
    Set Nd = New Node
    With Nd
        .X = X
        .Y = Y
        .Key = NodeData.Key.Text
        .Length = NodeData.Length.Text
    End With
    gNodes.Add NodeData.Key.Text, Nd
    
    gDirtyFile = True
    mDirtyWeb = True
    
Exit Sub
DuplicateKey:
    If Err = 457 Then
        MsgBox "The Node ' " & Nd.Key & " ' already exists", vbCritical, "Ignoring Duplicate Link"
    Else
        Err.Raise Err.Number, , Err.Description
    End If
End Sub
Public Sub EditNode(Nd As Node)
Dim Index As Integer
Dim AddEdit As frmAddNode
Dim Links As Variant, Nodes As Variant
Dim Key As String

    'This proc allows the user to change a node's data after they have added it.
    
    If Nd Is Nothing Then Exit Sub
    'Loop until the user gives us valid data
    Do
        Set AddEdit = New frmAddNode
        With AddEdit
            .Caption = "Edit Node"
            .Key = Nd.Key
            .Length = Nd.Length
            .Show vbModal, Me
            If .Cancelled Then Exit Sub
            If Not Len(.Key) = 0 And Not Len(.Length) = 0 And IsNumeric(.Length) Then Exit Do
            MsgBox "Please enter a Key and a numeric Length"
        End With
    Loop

    'Update the node with new data
    With Nd
        .Key = AddEdit.Key
        .Length = AddEdit.Length
    End With
    'Update any links that reference the affected node. Only the Length needs to be updated.
    Links = gLinks.Items
    For Index = 0 To UBound(Links)
        If Links(Index).Nd1 Is Nd Then
            Links(Index).Length = AddEdit.Length
        End If
    Next
    
    gDirtyFile = True
    mDirtyWeb = True

End Sub

Public Sub AddLink(Task1 As Node, Task2 As Node, Length As Long)
Dim Lk As Link
On Local Error GoTo DuplicateKey
    'This proc connects two nodes with a dependency link
    'Check to make sure the nodes exists and that they have not been presented before
    If Task1 Is Nothing Then Exit Sub
    If Task2 Is Nothing Then Exit Sub
    If gLinks.Exists(Task2.Key & "-" & Task1.Key) Then
        MsgBox "The Reverse Link ' " & Task2.Key & " - " & Task1.Key & " ' already exists", vbCritical, "Ignoring Duplicate Link"
        Exit Sub
    End If
    
    'Instantiate a new link and set up its properties
    Set Lk = New Link
    With Lk
        .Key = Task1.Key & "-" & Task2.Key
        .Length = Length
        Set .Nd1 = Task1
        Set .Nd2 = Task2
        gLinks.Add .Key, Lk
        'Add the new link its start node. This makes a circular reference
        Task1.Links.Add .Key, Lk
    End With
    
    If Not Task1.Key = cSTART Then Task2.Initiator = False
    If Not Task2.Key = cFINISH Then Task1.Terminator = False

    gDirtyFile = True
    mDirtyWeb = True
    
Exit Sub
DuplicateKey:
    If Err = 457 Then
        MsgBox "The Link ' " & Lk.Key & " ' already exists", vbCritical, "Ignoring Duplicate Link"
    Else
        Err.Raise Err.Number, , Err.Description
    End If
End Sub

Private Sub Form_Resize()
    If mResize Then RefreshDisplay
End Sub

Private Sub mnuAnalyseCriticalTree_Click()
    Height = mEditHeight
    Width = mEditWidth
    mnuAnalyseGantt.Checked = False
    mnuAnalyseCriticalTree.Checked = True
    RefreshDisplay
End Sub

Private Sub mnuAnalyseGantt_Click()
    mnuAnalyseGantt.Checked = True
    mnuAnalyseCriticalTree.Checked = False
    mEditHeight = Height
    mEditWidth = Width
    RefreshDisplay
End Sub

Private Sub mnuEditAddLink_Click()
    AddLink mSelection.Nd1, mSelection.Nd2, mSelection.Nd1.Length
    ClearSelection
End Sub

Private Sub mnuEditAddNode_Click()
    AddNode mXDown, mYDown
End Sub

Private Sub mnuEditAnalyseMode_Click()
    mnuModeAnalyse_Click
End Sub

Private Sub mnuEditClearSelection_Click()
    ClearSelection
    RefreshDisplay
End Sub

Private Sub mnuEditDeleteLink_Click()
    DeleteLink mSelection.Nd1, mSelection.Nd2
End Sub

Private Sub mnuEditDeleteNode_Click()
    DeleteNode mSelection.Nd1
End Sub

Private Sub mnuEditEditNode_Click()
    EditNode mSelection.Nd1
End Sub

Private Sub mnuExit_Click()
    If gDirtyFile Then
        If MsgBox("Save changes", vbYesNo + vbQuestion) = vbYes Then FileSave
    End If
    gDirtyFile = False
    Cleanup
End Sub


Private Sub mnuFileNew_Click()
    Clear
    FileSave eSaveAs
    RefreshDisplay
End Sub

Private Sub mnuFileOpen_Click()
    FileOpen
End Sub


Private Sub mnuFileSave_Click()
    FileSave
End Sub

Private Sub mnuFileSaveAs_Click()
    FileSave eSaveAs
End Sub

Public Sub RefreshDisplay()
Dim X As Single, Y As Single

    'This proc redraws the current display to reflect any changes.
    Cls
    If mnuModeEdit.Checked Then DrawGrid cEDITGRID, cEDITGRID
    If gNodes.Count = 0 Then Exit Sub
    If mDirtyWeb Then AddDummyNodes
    If mnuModeEdit.Checked Then
        'Place the dummy start and end nodes on the form
        X = cEDITGRID
        Y = (Height - cEDITGRID) \ 2
        SnapToGrid X, Y
        gNodes(cSTART).X = X
        gNodes(cSTART).Y = Y
        X = Width - cEDITGRID
        SnapToGrid X, Y
        gNodes(cFINISH).X = X
        gNodes(cFINISH).Y = Y
        'Draw the web structure
        DrawEdit mSelection.Nd1, mSelection.Nd2
    Else
        'Refind the critical path just in case something has been changed.
        FindCriticalPath
        'Draw the critical path directly or convert it to a gantt chart
        If mnuAnalyseGantt.Checked Then
            DrawGantt
        Else
            DrawCriticalPath
        End If
    End If
    
End Sub

Private Sub mnuHelpAnalysis_Click()
Dim Msg As String

    Msg = Msg & vbTab & vbTab & vbTab & "ANALYSING WEBS" & vbCrLf & vbCrLf
    Msg = Msg & "Build your own dependency web or load a web via the 'File' menu" & vbCrLf
    Msg = Msg & "Select 'Analysis Mode' from the Mode menu" & vbCrLf
    Msg = Msg & "You should now see the critical path tree through your web." & vbCrLf & vbCrLf
    
    Msg = Msg & "Things to Note" & vbCrLf
    Msg = Msg & " - The longest paths from the start node to all the other nodes are in blue" & vbCrLf
    Msg = Msg & " - The critical path is in red." & vbCrLf
    Msg = Msg & " - The critical path is the longest path that connects the start node to the finish node." & vbCrLf & vbCrLf
    
    Msg = Msg & "Gantt view" & vbCrLf
    Msg = Msg & " - Select 'Analysis Mode' from the Mode menu" & vbCrLf
    Msg = Msg & " - Select 'Gantt Chart' from the Analysis menu " & vbCrLf
    Msg = Msg & " - Time runs along the top and task ID runs down the left." & vbCrLf
    Msg = Msg & " - Those tasks that lie on the critical path are shown in red." & vbCrLf
    
    MsgBox Msg, vbQuestion
End Sub

Private Sub mnuHelpBuilding_Click()
Dim Msg As String

    Msg = Msg & vbTab & vbTab & vbTab & vbTab & "BUILDING WEBS" & vbCrLf & vbCrLf
    Msg = Msg & "Each web is composed of (white) task nodes which are interconnected via one way links" & vbCrLf
    Msg = Msg & "Each link  has a  number, this is the Length of its 'From Node'," & vbCrLf
    Msg = Msg & "Each link has a small green dot to indicate that link's direction. The node closest to the green dot is the 'To Node'" & vbCrLf & vbCrLf
    
    Msg = Msg & "Click Actions" & vbCrLf
    Msg = Msg & " - LC on a node to select it and it will go green (From Node)" & vbCrLf
    Msg = Msg & " - RC on a second node and it will go red (To Node). Now you can link green to red" & vbCrLf
    Msg = Msg & " - LC and MM will reposition green node" & vbCrLf
    Msg = Msg & " - LC on the form to deselect all." & vbCrLf
    Msg = Msg & " - RC anywhere to bring up the action menu." & vbCrLf & vbCrLf
    
    Msg = Msg & "The actions you can perform depend on whether you have 0,1,2 nodes currently selected." & vbCrLf
    Msg = Msg & " - If 0 nodes are selected you can add a new node." & vbCrLf
    Msg = Msg & " - If 1 node is selected you can edit that node." & vbCrLf
    Msg = Msg & " - If 2 nodes are selected you can add a new link. New links start at the green node and go to the red node" & vbCrLf & vbCrLf
    MsgBox Msg, vbQuestion
    
End Sub


Private Sub mnuModeAnalyse_Click()
    mEditHeight = Height
    mEditWidth = Width
    If gDirtyFile Then FileSave
    mnuModeAnalyse.Checked = True
    mnuModeEdit.Checked = False
    mnuEdit.Enabled = False
    mnuAnalyse.Enabled = True
    MousePointer = vbDefault
    RefreshDisplay
End Sub

Private Sub mnuModeEdit_Click()
    Height = mEditHeight
    Width = mEditWidth
    mnuModeEdit.Checked = True
    mnuModeAnalyse.Checked = False
    mnuEdit.Enabled = True
    mnuAnalyse.Enabled = False
    RefreshDisplay
End Sub



Public Sub SetEditMenu()

    mnuEditEditNode.Enabled = False
    mnuEditAddNode.Enabled = False
    mnuEditAddLink.Enabled = False
    mnuEditDeleteNode.Enabled = False
    mnuEditDeleteLink.Enabled = False
    
    If mSelection.Nd1 Is Nothing Then
        mnuEditAddNode.Enabled = True
        Exit Sub
    Else
        If mSelection.Nd2 Is Nothing Then
            mnuEditEditNode.Enabled = True
            mnuEditDeleteNode.Enabled = True
        Else
            mnuEditAddLink.Enabled = True
            mnuEditDeleteLink.Enabled = True
        End If
    End If
    
End Sub

Public Sub DeleteNode(Nd As Node)
Dim Links As Variant, Nodes As Variant
Dim Index As Integer, NdLk As Integer
Dim Lk As Link

    'This proc removes the specified node and any links that reference it.
    If Nd Is Nothing Then Exit Sub
    Links = gLinks.Items
    For Index = 0 To UBound(Links)
        Set Lk = Links(Index)
        If Nd Is Lk.Nd1 Or Nd Is Lk.Nd2 Then gLinks.Remove Lk.Key
    Next
    
    'Attach any nodes left dangling back up to the dummy start / end node's
    Nodes = gNodes.Items
    For Index = 0 To UBound(Nodes)
        Links = Nodes(Index).Links.Items
        For NdLk = 0 To UBound(Links)
            Set Lk = Links(NdLk)
            If Nd Is Lk.Nd1 Then
                Nodes(Index).Links.Remove Lk.Key
                If Lk.Nd1.Links.Count = 0 Then Lk.Nd1.Initiator = True
                If Lk.Nd2.Links.Count = 0 Then Lk.Nd2.Terminator = True
            ElseIf Nd Is Lk.Nd2 Then
                Nodes(Index).Links.Remove Lk.Key
                If Lk.Nd2.Links.Count = 0 Then Lk.Nd2.Initiator = True
                If Lk.Nd1.Links.Count = 0 Then Lk.Nd1.Terminator = True
            End If
        Next
    Next
    
    'Actually remove the node
    gNodes.Remove Nd.Key
    ClearSelection

    gDirtyFile = True
    mDirtyWeb = True
        
End Sub
Public Sub DeleteLink(Task1 As Node, Task2 As Node)
Dim Links As Variant, Nodes As Variant
Dim Index As Integer, NdLk As Integer
Dim Lk As Link
Dim Nd As Node

    'This proc removes the dependency link between the two specified tasks

    If Task1 Is Nothing Then Exit Sub
    If Task2 Is Nothing Then Exit Sub
    'Get the links out of the dictionary
    'If the link references the two tasks then remove it
    Links = gLinks.Items
    For Index = 0 To UBound(Links)
        Set Lk = Links(Index)
        If Task1 Is Lk.Nd1 And Task2 Is Lk.Nd2 Then
            gLinks.Remove Lk.Key
        ElseIf Task1 Is Lk.Nd2 And Task2 Is Lk.Nd1 Then
            gLinks.Remove Lk.Key
        End If
    Next
    'Check each node's list of links removing any link that reference the two specified tasks
    Nodes = gNodes.Items
    For Index = 0 To UBound(Nodes)
        Links = Nodes(Index).Links.Items
        For NdLk = 0 To UBound(Links)
            Set Lk = Links(NdLk)
            If Task1 Is Lk.Nd1 And Task2 Is Lk.Nd2 Then
                Nodes(Index).Links.Remove Lk.Key
            ElseIf Task1 Is Lk.Nd2 And Task2 Is Lk.Nd1 Then
                Nodes(Index).Links.Remove Lk.Key
            End If
        Next
    Next
    
    ClearSelection

    gDirtyFile = True
    mDirtyWeb = True
    
End Sub


Public Sub AddDummyNodes()
Dim X As Single, Y As Single
Dim Nodes As Variant
Dim Index As Integer
Dim Nd As Node

    'This proc creates and links the dummy Start and Finish nodes
    
    'Delete them if they exists.
    If gNodes.Exists(cSTART) Then
        DeleteNode gNodes(cSTART)
        DeleteNode gNodes(cFINISH)
    End If
    
    'Instantiate the Start node
    X = cEDITGRID
    Y = (Height - cEDITGRID) \ 2
    SnapToGrid X, Y
    Set Nd = New Node
    With Nd
        .X = X
        .Y = Y
        .Key = cSTART
        .Initiator = False
        .Terminator = False
    End With
    gNodes.Add cSTART, Nd
    
    'Instantiate the Finish node
    X = Width - cEDITGRID
    SnapToGrid X, Y
    Set Nd = New Node
    With Nd
        .X = X
        .Y = Y
        .Key = cFINISH
        .Initiator = False
        .Terminator = False
    End With
    gNodes.Add cFINISH, Nd
    
    'Add a link from the Start node to any node marked as an Initiator
    'Add a link from any node marked as an Terminator to the Finish Node
    Nodes = gNodes.Items
    For Index = 0 To UBound(Nodes)
        Set Nd = Nodes(Index)
        If Nd.Initiator Then AddLink gNodes(cSTART), Nd, 0
        If Nd.Terminator Then AddLink Nd, gNodes(cFINISH), Nd.Length
    Next
    
    mDirtyWeb = False

End Sub

Public Sub PrintText(X As Single, Y As Single, Text As String)
    'Prints text on the form.
    CurrentX = X
    CurrentY = Y
    Print Text
End Sub

Public Property Let Resize(ByVal vNewValue As Variant)
    mResize = vNewValue
End Property
Public Property Let DirtyWeb(ByVal vNewValue As Variant)
    mDirtyWeb = vNewValue
End Property
