Attribute VB_Name = "Main"
Option Explicit

Public Const cEDITGRID As Integer = 500
Public Const cRADIUS As Integer = 160
Public Const cSTART As String = "S*"
Public Const cFINISH As String = "F*"
Private Const cSELRADIUS As Integer = cRADIUS * cRADIUS
Private Const cNOSTATUS As Integer = 0
Private Const cCANDIDATE As Integer = 1
Private Const cPROCESSED As Integer = 2
Private Const cMININT As Integer = -32767

Public gLinks As Dictionary
Public gNodes As Dictionary
Private mForm As frmCriticalAnalyser
Public Sub FindCriticalPath()
Dim Candidates As New Collection
Dim Index As Integer, BestDist As Integer, NewDist As Integer, BestNd As Integer
Dim Nodes As Variant, Links As Variant
Dim Nd As Node, ToNode As Node
Dim Lk As Link

    If gNodes.Count = 0 Then Exit Sub
    Nodes = gNodes.Items
    For Index = 0 To UBound(Nodes)
        With Nodes(Index)
            Set .InLink = Nothing
            .Status = cNOSTATUS
            .Distance = 0
        End With
    Next

    Links = gLinks.Items
    For Index = 0 To UBound(Links)
        With Links(Index)
            .InTree = False
            .Critical = False
        End With
    Next
    
    Candidates.Add gNodes(cSTART)
    
    Do While Candidates.Count > 0
        BestDist = cMININT
        For Index = 1 To Candidates.Count
            NewDist = Candidates(Index).Distance
            If NewDist > BestDist Then
                BestDist = NewDist
                BestNd = Index
            End If
        Next
        Set Nd = Candidates(BestNd)
        Candidates.Remove BestNd
        Nd.Status = cPROCESSED
        Links = Nd.Links.Items
        For Index = 0 To UBound(Links)
            Set Lk = Links(Index)
            If Nd Is Lk.Nd1 Then
                Set ToNode = Lk.Nd2
            Else
                Set ToNode = Lk.Nd1
            End If
            If ToNode.Status = cNOSTATUS Then
                Candidates.Add ToNode
                ToNode.Status = cCANDIDATE
                ToNode.Distance = BestDist + Lk.Cost
                Set ToNode.InLink = Lk
            ElseIf ToNode.Status = cCANDIDATE Then
                NewDist = BestDist + Lk.Cost
                If NewDist > ToNode.Distance Then
                    ToNode.Distance = NewDist
                    Set ToNode.InLink = Lk
                End If
            End If
        Next
    Loop
    
    Nodes = gNodes.Items
    For Index = 0 To UBound(Nodes)
        If Not Nodes(Index).InLink Is Nothing Then Nodes(Index).InLink.InTree = True
    Next
    
    Set Nd = gNodes(cFINISH)
    Do
        Nd.InLink.Critical = True
        Set Nd = Nd.InLink.Nd1
    Loop Until Nd Is gNodes(cSTART)
    
End Sub



Public Sub Main()


    Set mForm = New frmCriticalAnalyser
    Set gLinks = New Dictionary
    Set gNodes = New Dictionary
    Load mForm
    mForm.Show
    
End Sub
Public Sub DrawCriticalPath()
Dim Nodes As Variant, Links As Variant
Dim X As Single, Y As Single
Dim Index As Integer
Dim Nd As Node
Dim Lk As Link

    With mForm
        .ForeColor = vbBlack:  .FillColor = .BackColor
        Links = gLinks.Items
        For Index = 0 To UBound(Links)
            Set Lk = Links(Index)
            .ForeColor = vbBlack: .DrawWidth = 1
            If Lk.Critical Then
                .ForeColor = vbRed: .DrawWidth = 2
            ElseIf Lk.InTree Then
                .ForeColor = vbBlue: .DrawWidth = 2
            End If
            'Draw the links
            mForm.Line (Lk.Nd1.X, Lk.Nd1.Y)-(Lk.Nd2.X, Lk.Nd2.Y)
        Next
        
        'Draw the nodes
        .DrawWidth = 1
        Nodes = gNodes.Items
        For Index = 0 To UBound(Nodes)
            Set Nd = Nodes(Index)
            .FillColor = vbWhite: .ForeColor = vbBlack
            If Nd Is gNodes(cSTART) Or Nd Is gNodes(cFINISH) Then .FillColor = vbRed: .ForeColor = vbWhite
            mForm.Circle (Nd.X, Nd.Y), cRADIUS
            .PrintText Nd.X - .TextWidth(Nd.Key) / 2, Nd.Y - .TextHeight(Nd.Key) / 2, Nd.Key
        Next
    End With
    
End Sub



Public Sub DrawGantt()
Dim TotalTime As Integer, Index As Integer, Cw As Integer, Ch As Integer, MaxKeyLen As Integer, Cost As Integer
Dim Links As Variant, Nodes As Variant
Dim X As Single, Y As Single
Dim Lk As Link
Dim Nd As Node

    Set Nd = gNodes(cFINISH)
    Do
        TotalTime = TotalTime + Nd.InLink.Cost
        Set Nd = Nd.InLink.Nd1
    Loop Until Nd Is gNodes(cSTART)
    
    With mForm
        .ForeColor = vbBlack
        .PrintText 100, 100, "Project Time = " & TotalTime
        Ch = .Height \ (gNodes.Count + 2)
        If Ch < 200 Then Ch = 200
        Nodes = gNodes.Items
        For Index = 0 To UBound(Nodes)
            Set Nd = Nodes(Index)
            X = 0: Y = 0
            If Not Nd Is gNodes(cSTART) And Not Nd Is gNodes(cFINISH) Then
                .PrintText 50, Ch * (Index + 1), Nd.Key
                If mForm.TextWidth(Nd.Key) > MaxKeyLen Then MaxKeyLen = mForm.TextWidth(Nd.Key)
            End If
        Next
        MaxKeyLen = MaxKeyLen + 100
        Cw = (.Width - MaxKeyLen) \ (TotalTime + 1)
        If Cw < 200 Then Cw = 200
        .DrawWidth = 10
        For Index = 0 To UBound(Nodes)
            Set Nd = Nodes(Index)
            If Not Nd Is gNodes(cSTART) And Not Nd Is gNodes(cFINISH) Then
                X = MaxKeyLen + (Nd.Distance * Cw)
                Y = (Index * Ch) + (Ch * 1.5)
                If Not Nd.Links.Count = 0 Then
                    Links = Nd.Links.Items
                    Cost = (Links(0).Cost * Cw)
                End If
                .ForeColor = vbBlue
                If Nd.InLink.Critical Then .ForeColor = vbRed
                mForm.Line (X, Y)-(X + Cost, Y)
            End If
        Next

        DrawGrid Ch, Cw, MaxKeyLen
    End With


End Sub


Public Sub FileOpen()
Dim XNodes As IXMLDOMNodeList, XLinks As IXMLDOMNodeList
Dim XML As DOMDocument, XRoot As IXMLDOMElement
Dim Index As Integer

    If mDirtyFile Then
        If MsgBox("Save changes", vbYesNo + vbQuestion) = vbYes Then FileSave
    End If
    
    Clear
    Set XML = New DOMDocument
    XML.async = False
    SetFileName eOpen
    If Len(mFileName) = 0 Then Exit Sub
    XML.Load mFileName
    Set XRoot = XML.documentElement
    Set XNodes = XRoot.selectNodes("Node")
    Set XLinks = XRoot.selectNodes("Link")
    
    'Set the form's height and wKeyth
    mNoResize = True
    Height = XRoot.Attributes(0).Text
    Width = XRoot.Attributes(1).Text
    mNoResize = False
    'Add in all the nodes
    For Index = 0 To XNodes.length - 1
        AddNode XNodes(Index).childNodes(0).Text, XNodes(Index).childNodes(1).Text, XNodes(Index).childNodes(2).Text
    Next
    'Add in all the links
    For Index = 0 To XLinks.length - 1
        AddLink gNodes(XLinks(Index).childNodes(0).Text), gNodes(XLinks(Index).childNodes(1).Text), XLinks(Index).childNodes(2).Text
    Next

    mDirtyWeb = True
    RefreshDisplay
    mDirtyFile = False
    
End Sub


Public Sub FileSave()
Dim XRoot As IXMLDOMElement, XNd As IXMLDOMElement, XLk As IXMLDOMElement
Dim Nd2 As IXMLDOMElement, Nd1 As IXMLDOMElement, Cost As IXMLDOMElement
Dim X As IXMLDOMElement, Y As IXMLDOMElement, Key As IXMLDOMElement
Dim Nodes As Variant, Links As Variant
Dim XML As DOMDocument
Dim Index As Integer
Dim Nd As Node
Dim Lk As Link

    If Len(mFileName) = 0 Then
        SetFileName eSaveAs
        If Len(mFileName) = 0 Then Exit Sub
    End If
    
    Set XML = New DOMDocument
    XML.async = False
    Set XRoot = XML.createElement("Web")
    XRoot.setAttribute "Height", Height
    XRoot.setAttribute "Width", Width
    
    Nodes = gNodes.Items
    For Index = 0 To UBound(Nodes)
        Set Nd = Nodes(Index)
        If Not Nd.Key = cSTART And Not Nd.Key = cFINISH Then
            Set XNd = XML.createElement("Node")
            Set Key = XML.createElement("Key")
            Set X = XML.createElement("X")
            Set Y = XML.createElement("Y")
            Key.Text = Nd.Key
            X.Text = Nd.X
            Y.Text = Nd.Y
            XNd.appendChild Key
            XNd.appendChild X
            XNd.appendChild Y
            XRoot.appendChild XNd
        End If
    Next
    
    Links = gLinks.Items
    For Index = 0 To UBound(Links)
        Set Lk = Links(Index)
        If Not Lk.Nd1.Key = cSTART And Not Lk.Nd2.Key = cFINISH Then
            Set XLk = XML.createElement("Link")
            Set Nd1 = XML.createElement("Nd1")
            Set Nd2 = XML.createElement("Nd2")
            Set Cost = XML.createElement("Cost")
            Nd1.Text = Lk.Nd1.Key
            Nd2.Text = Lk.Nd2.Key
            Cost.Text = Lk.Cost
            XLk.appendChild Nd1
            XLk.appendChild Nd2
            XLk.appendChild Cost
            XRoot.appendChild XLk
        End If
    Next
    
    XML.appendChild XRoot
    XML.save mFileName
    mDirtyFile = False
    
End Sub


Public Sub Cleanup()

    Set gNodes = Nothing
    Set gLinks = Nothing
    Unload mForm
    Set mForm = Nothing
    End
    
End Sub

Public Sub DrawEdit(SelNd1 As Node, SelNd2 As Node)
Dim Nodes As Variant, Links As Variant
Dim X As Single, Y As Single
Dim Index As Integer
Dim Lk As Link
Dim Nd As Node

    DrawGrid cEDITGRID, cEDITGRID
    With mForm
        .ForeColor = vbBlack:  .FillColor = .BackColor
        Links = gLinks.Items
        For Index = 0 To UBound(Links)
            Set Lk = Links(Index)
            'Draw the links
            mForm.Line (Lk.Nd1.X, Lk.Nd1.Y)-(Lk.Nd2.X, Lk.Nd2.Y)
            X = (Lk.Nd1.X + Lk.Nd2.X) \ 2
            Y = (Lk.Nd1.Y + Lk.Nd2.Y) \ 2
            'Print the link costs
            .DrawStyle = vbInvisible
            mForm.Circle (X, Y), cRADIUS
            .DrawStyle = vbSolid
            .PrintText X - .TextWidth(Lk.Cost) / 2, Y - .TextHeight(Lk.Cost) / 2, Lk.Cost
            'Draw in the link-direction indicator-circles
            X = Lk.Nd1.X + ((Lk.Nd2.X - Lk.Nd1.X)) * 0.75
            Y = Lk.Nd1.Y + ((Lk.Nd2.Y - Lk.Nd1.Y)) * 0.75
            .FillColor = vbGreen
            mForm.Circle (X, Y), cRADIUS \ 5
            .FillColor = .BackColor
        Next
        'Draw the nodes
        .DrawStyle = vbSolid
        Nodes = gNodes.Items
        For Index = 0 To UBound(Nodes)
            Set Nd = Nodes(Index)
            .FillColor = vbWhite: .ForeColor = vbBlack
            If Nd Is SelNd1 Or Nd Is SelNd2 Then .FillColor = vbBlue
            If Nd Is gNodes(cSTART) Or Nd Is gNodes(cFINISH) Then .FillColor = vbRed: .ForeColor = vbWhite
            mForm.Circle (Nd.X, Nd.Y), cRADIUS
            .PrintText Nd.X - .TextWidth(Nd.Key) / 2, Nd.Y - .TextHeight(Nd.Key) / 2, Nd.Key
        Next
    End With
    
End Sub



Public Sub DrawGrid(CellH As Integer, CellW As Integer, Optional XOffset As Integer, Optional YOffset As Integer)
Dim Index As Long
Dim OldColor As Long, OldWidth As Long

    'Draw Grid
    With mForm
        OldColor = .ForeColor: OldWidth = .DrawWidth
        .DrawWidth = 1: .ForeColor = &H8000000C
        For Index = XOffset To .Width Step CellW
            mForm.Line (Index, 0)-(Index, .Height)
        Next
        For Index = YOffset To .Height - CellH Step CellH
            mForm.Line (0, Index)-(.Width, Index)
        Next
        .DrawWidth = OldWidth: .ForeColor = OldColor
    End With
    
End Sub

Public Sub SnapToGrid(X As Single, Y As Single)
Dim RoundedX As Integer, RoundedY As Integer

    RoundedX = ((X \ cEDITGRID) * cEDITGRID)
    If X <= RoundedX + cEDITGRID \ 2 Then
        X = RoundedX
    Else
        X = RoundedX + cEDITGRID
    End If
    
    RoundedY = ((Y \ cEDITGRID) * cEDITGRID)
    If Y <= RoundedY + cEDITGRID \ 2 Then
        Y = RoundedY
    Else
        Y = RoundedY + cEDITGRID
    End If
    
End Sub

